<!-- eslint-disable vue/valid-v-for -->
<template>
  <q-select
    v-model="internalValue"
    style="min-width: 150px"
    :dense="dense"
    :filled="filled"
    :multiple="multiple"
    :label="label"
    use-chips
    emit-value
    stack-label
    map-options
    @update:model-value="updateValue"
    :option-disable="
      (opt) => (Object(opt) === opt ? opt.value === 'G' && !gestion : true)
    "
    :options="ramas"
    :hide-bottom-space="hideBottomSpace"
    :error-message="errorMessage"
    :error="error"
  >
    <template v-slot:selected>
      <q-chip
        v-for="item in internalValue"
        dense
        square
        :color="Array.prototype.find.call(ramas, (x) => x.value === item).color"
        text-color="white"
      >
        {{ Array.prototype.find.call(ramas, (x) => x.value === item).label }}
      </q-chip>
    </template>

    <template v-slot:option="scope">
      <q-item v-bind="scope.itemProps">
        <!--
        <q-item-section avatar>
          <q-icon :name="scope.opt.icon" />
        </q-item-section>
        -->
        <q-item-section>
          <q-item-label>
            <q-chip
              dark
              square
              :color="scope.opt.color"
              :label="scope.opt.label"
          /></q-item-label>
        </q-item-section>
      </q-item>
    </template>
  </q-select>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, toRefs, watch } from 'vue';

const ramas = [
  {
    label: 'Castores',
    value: 'T',
    color: 'orange',
    icon: 'fas os-saac-oms',
  },
  {
    label: 'Lob&Lob',
    value: 'L',
    color: 'amber',
    icon: 'fas os-saac-insignia-lyl',
  },
  {
    label: 'Scouts',
    value: 'S',
    color: 'green',
    icon: 'fas os-saac-insignia-scout',
  },
  {
    label: 'Caminantes',
    value: 'C',
    color: 'blue',
    icon: 'fas os-saac-insignia-caminantes',
  },
  {
    label: 'Rovers',
    value: 'R',
    color: 'red',
    icon: 'fas os-saac-insignia-rover',
  },
  {
    label: 'Gestión institucional',
    value: 'G',
    color: 'purple',
    icon: 'fas os-funcion-dirigente',
  },
];

export default defineComponent({
  name: 'MyInput',
  props: {
    modelValue: {
      type: String as PropType<string | string[] | null>,
      required: true,
    },
    label: {
      type: String as PropType<string>,
      required: false,
      default: 'Seleccionar Rama',
    },

    dense: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    filled: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    multiple: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    gestion: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: true,
    },

    error: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
    errorMessage: {
      type: String as PropType<string>,
      required: false,
    },

    hideBottomSpace: {
      type: Boolean as PropType<boolean>,
      required: false,
      default: false,
    },
  },

  emits: ['update:modelValue'],
  setup(props, { emit }) {
    const { modelValue } = toRefs(props);
    const internalValue = ref(modelValue);

    watch(
      () => props.modelValue,
      (newValue: string[] | string | null) => {
        internalValue.value = newValue;
      }
    );

    function updateValue(value: string) {
      internalValue.value = value;
      emit('update:modelValue', value);
    }

    return {
      internalValue,
      updateValue,
      ramas,
    };
  },
});
</script>
